import java.awt.*;
import javax.swing.UIManager;
import javax.swing.plaf.metal.MetalLookAndFeel;
import java.net.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;

public class POP3 {
    public POP3() {
        POP3Frame frame = new POP3Frame();

        frame.validate();

        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        new POP3();
    }
}

class ProfileDialog2 extends JDialog implements ActionListener {
    JPanel panel1 = new JPanel();
    JPanel Panel2 = new JPanel();
    JPanel Panel3 = new JPanel();
    JPanel Panel4 = new JPanel();
    JPanel Panel5 = new JPanel();

    Border border1;
    Border border2;
    Border border3;

    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();

    GridLayout gridLayout1 = new GridLayout();
    GridLayout gridLayout2 = new GridLayout();

    TitledBorder titledborder2;

    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();

    JTextField jHost = new JTextField();
    JTextField jUser = new JTextField();
    JTextField jPort = new JTextField();
    JTextField jPass = new JTextField();

    JButton jButtonOK = new JButton();
    JButton jButtonCancel = new JButton();

    public ProfileDialog2(Frame parent) {
        super(parent);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);

        try {
            createDialog();
            pack();

	        loadProperties();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void createDialog() throws Exception {
        this.setTitle("POP3 Profile");

        this.setResizable(false);

        panel1.setLayout(borderLayout1);
        panel1.setBorder(BorderFactory.createEtchedBorder());
        panel1.setMinimumSize(new Dimension(290, 210));
        panel1.setPreferredSize(new Dimension(290, 210));

        titledborder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Incoming Mail (POP3)");
        Panel2.setBorder(titledborder2);
        Panel2.setMinimumSize(new Dimension(10, 120));
        Panel2.setPreferredSize(new Dimension(10, 120));
        Panel2.setLayout(borderLayout2);

        border1 = BorderFactory.createEmptyBorder(4,0,4,0);
        Panel3.setBorder(border1);
        Panel3.setMinimumSize(new Dimension(10, 50));
        Panel3.setPreferredSize(new Dimension(10, 50));

        border2 = BorderFactory.createEmptyBorder(4,10,4,2);
        Panel4.setBorder(border2);

        gridLayout1.setRows(4);
        gridLayout1.setColumns(1);
        gridLayout1.setHgap(2);
        gridLayout1.setVgap(2);
        Panel4.setMinimumSize(new Dimension(80, 10));
        Panel4.setPreferredSize(new Dimension(80, 10));
        Panel4.setLayout(gridLayout1);

        border3 = BorderFactory.createEmptyBorder(4,2,4,5);
        gridLayout2.setRows(4);
        gridLayout2.setColumns(1);
        gridLayout2.setHgap(2);
        gridLayout2.setVgap(4);
        Panel5.setLayout(gridLayout2);
        Panel5.setBorder(border3);

        jLabel1.setText("POP3 Host:");
        jLabel2.setText("POP3 Port:");
        jLabel3.setText("User Name:");
        jLabel4.setText("Password:");

        jButtonOK.setMaximumSize(new Dimension(80, 30));
        jButtonOK.setMinimumSize(new Dimension(80, 30));
        jButtonOK.setPreferredSize(new Dimension(80, 30));
        jButtonOK.setMnemonic('O');
        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonOK_actionPerformed(e);
            }
        });

        jButtonCancel.setMaximumSize(new Dimension(80, 30));
        jButtonCancel.setMinimumSize(new Dimension(80, 30));
        jButtonCancel.setPreferredSize(new Dimension(80, 30));
        jButtonCancel.setMnemonic('C');
        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonCancel_actionPerformed(e);
            }
        });

        this.getContentPane().add(panel1, BorderLayout.WEST);

        Panel4.add(jLabel1, null);
        Panel4.add(jLabel2, null);
        Panel4.add(jLabel3, null);
        Panel4.add(jLabel4, null);
        Panel2.add(Panel4, BorderLayout.WEST);

        Panel5.add(jHost, null);
        Panel5.add(jPort, null);
        Panel5.add(jUser, null);
        Panel5.add(jPass, null);
        Panel2.add(Panel5, BorderLayout.CENTER);

        panel1.add(Panel2, BorderLayout.CENTER);

        Panel3.add(jButtonOK, null);
        Panel3.add(jButtonCancel, null);

        panel1.add(Panel3, BorderLayout.SOUTH);
	}

    void loadProperties() {
		try {
			Properties p = new Properties();

			FileInputStream in = new FileInputStream("pop3.properties");

			p.load(in);

            jHost.setText(p.getProperty("pop3.host")) ;
            jPort.setText(p.getProperty("pop3.port"));
            jUser.setText(p.getProperty("pop3.username"));
            jPass.setText(p.getProperty("pop3.password"));

            in.close() ;
		}
		catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
	}

    void saveProperties() {
		try {
			Properties p = new Properties();

			FileOutputStream os = new FileOutputStream("pop3.properties");

            p.setProperty("pop3.host", jHost.getText()) ;
            p.setProperty("pop3.port", jPort.getText()) ;
            p.setProperty("pop3.username", jUser.getText()) ;
            p.setProperty("pop3.password", jPass.getText()) ;

			p.store(os, null);
			os.close();
        }
		catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
	}

    protected void processWindowEvent(WindowEvent e) {
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            cancel();
        }
        super.processWindowEvent(e);
    }

    void cancel() {
        dispose();
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == jButtonOK) {
            saveProperties();
        }
        else if (e.getSource() == jButtonCancel) {
            cancel();
        }
    }

    void jButtonOK_actionPerformed(ActionEvent e) {
        saveProperties();
        cancel();
    }

    void jButtonCancel_actionPerformed(ActionEvent e) {
        cancel();
    }
}

class POP3Frame extends JFrame {
    JPanel contentPane;

    JTabbedPane jTabbedPane1 = new JTabbedPane();
    BorderLayout borderLayout0 = new BorderLayout();
    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    BorderLayout borderLayout3 = new BorderLayout();
    BorderLayout borderLayout4 = new BorderLayout();
    BorderLayout borderLayout5 = new BorderLayout();
    BorderLayout borderLayout6 = new BorderLayout();
    BorderLayout borderLayout7 = new BorderLayout();
    GridLayout gridLayout1 = new GridLayout();
    GridLayout gridLayout2 = new GridLayout();
    Border border1;
    Border border2;
    Border border3;
    Border border4;
    Border border5;
    Border border7;

    ImageIcon image1;
    ImageIcon image2;
    ImageIcon image3;
    ImageIcon image4;

    JPanel Panel1 = new JPanel();
    JPanel Panel2 = new JPanel();
    JPanel Panel3 = new JPanel();
    JPanel Panel4 = new JPanel();
    JPanel Panel5 = new JPanel();
    JPanel Panel6 = new JPanel();
    JPanel Panel7 = new JPanel();
    JPanel Panel8 = new JPanel();
    JPanel Panel9 = new JPanel();
    JPanel Panel10 = new JPanel();
    JPanel Panel11 = new JPanel();

    JToolBar jToolBar = new JToolBar();
    JButton jButtonReceive = new JButton();
    JButton jButtonPrevious = new JButton();
    JButton jButtonNext = new JButton();
    JButton jButtonClear = new JButton();
    JButton jButtonClear1 = new JButton();

    JMenuBar jMenuBar1 = new JMenuBar();
    JMenu jMenuFile = new JMenu();
    JMenuItem jMenuFileProfile = new JMenuItem();
    JMenuItem jMenuFileExit = new JMenuItem();

    JMenu jMenuView = new JMenu();
    JMenuItem jMenuViewPrevious = new JMenuItem();
    JMenuItem jMenuViewNext = new JMenuItem();

    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JLabel jStatus = new JLabel();

    JTextField jFrom = new JTextField();
    JTextField jDate = new JTextField();
    JTextField jReceipients = new JTextField();
    JTextField jSubject = new JTextField();

    JEditorPane jText = new JEditorPane();
    JTextArea jHeader = new JTextArea();
    JTextArea jLog = new JTextArea();

    JScrollPane jScrollPane1 = new JScrollPane();
    JScrollPane jScrollPane2 = new JScrollPane();
    JScrollPane jScrollPane3 = new JScrollPane();

    private BufferedReader inData;
    private BufferedWriter outData;
	private Socket cs;

    private static String host, port, user, pass;
    private static String linesep ;
    private int totalMail, currentMail, mailSize;

    public POP3Frame() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            createFrame();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void createFrame() throws Exception  {
        this.setLocale(new java.util.Locale("zh", "TW", ""));

		// Get current classloader
   		ClassLoader cl = this.getClass().getClassLoader();
   		// Create icons
        image1 = new ImageIcon(cl.getResource("mail.gif"));
        setIconImage(image1.getImage());

        image2 = new ImageIcon(cl.getResource("receive.gif"));
        image3 = new ImageIcon(cl.getResource("left.gif"));
        image4 = new ImageIcon(cl.getResource("right.gif"));

        contentPane = (JPanel) this.getContentPane();
        contentPane.setLayout(borderLayout0);
        this.setSize(new Dimension(300, 350));
        this.setTitle("POP3");

        jButtonReceive.setIcon(image2);
        jButtonReceive.setMinimumSize(new Dimension(35, 35));
        jButtonReceive.setMaximumSize(new Dimension(35, 35));
        jButtonReceive.setHorizontalTextPosition(SwingConstants.CENTER);
        jButtonReceive.setVerticalTextPosition(SwingConstants.BOTTOM);
        jButtonReceive.setToolTipText("Receive Mail");
        jButtonReceive.setPreferredSize(new Dimension(35, 35));
        jButtonReceive.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonReceive_actionPerformed(e);
            }
        });

        jButtonPrevious.setIcon(image3);
        jButtonPrevious.setMaximumSize(new Dimension(35, 35));
        jButtonPrevious.setMinimumSize(new Dimension(35, 35));
        jButtonPrevious.setPreferredSize(new Dimension(35, 35));
        jButtonPrevious.setToolTipText("Previous Mail");
        jButtonPrevious.setVerticalTextPosition(SwingConstants.BOTTOM);
        jButtonPrevious.setHorizontalTextPosition(SwingConstants.CENTER);
        jButtonPrevious.setEnabled(false);
        jButtonPrevious.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonPrevious_actionPerformed(e);
            }
        });

        jButtonNext.setIcon(image4);
        jButtonNext.setMaximumSize(new Dimension(35, 35));
        jButtonNext.setMinimumSize(new Dimension(35, 35));
        jButtonNext.setHorizontalTextPosition(SwingConstants.CENTER);
        jButtonNext.setVerticalTextPosition(SwingConstants.BOTTOM);
        jButtonNext.setToolTipText("Next Mail");
        jButtonNext.setPreferredSize(new Dimension(35, 35));
        jButtonNext.setEnabled(false);
        jButtonNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonNext_actionPerformed(e);
            }
        });

        jButtonClear.setMaximumSize(new Dimension(80, 30));
        jButtonClear.setMinimumSize(new Dimension(80, 30));
        jButtonClear.setPreferredSize(new Dimension(80, 30));
        jButtonClear.setMnemonic('C');
        jButtonClear.setText("Clear");
        jButtonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonClear_actionPerformed(e);
            }
        });

        jButtonClear1.setMaximumSize(new Dimension(80, 30));
        jButtonClear1.setMinimumSize(new Dimension(80, 30));
        jButtonClear1.setPreferredSize(new Dimension(80, 30));
        jButtonClear1.setMnemonic('C');
        jButtonClear1.setText("Clear");
        jButtonClear1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonClear1_actionPerformed(e);
            }
        });

        jMenuFile.setText("File");
        jMenuFile.setMnemonic('F');

        jMenuFileProfile.setText("Profile");
        jMenuFileProfile.setMnemonic('P');
        jMenuFileProfile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuFileProfile_actionPerformed(e);
            }
        });

        jMenuFileExit.setText("Exit");
        jMenuFileExit.setMnemonic('X');
        jMenuFileExit.addActionListener(new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                jMenuFileExit_actionPerformed(e);
            }
        });

        jMenuView.setText("View");
        jMenuView.setMnemonic('V');
        jMenuView.setEnabled(false);

        jMenuViewPrevious.setText("Previous Mail");
        jMenuViewPrevious.setMnemonic('P');
        jMenuViewPrevious.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonPrevious_actionPerformed(e);
            }
        });

        jMenuViewNext.setText("Next Mail");
        jMenuViewNext.setMnemonic('N');
        jMenuViewNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonNext_actionPerformed(e);
            }
        });

        Panel1.setLayout(borderLayout1);
        Panel2.setLayout(borderLayout2);
        Panel3.setLayout(borderLayout3);
        Panel4.setLayout(borderLayout4);

        Panel5.setLayout(borderLayout5);
        Panel5.setBorder(BorderFactory.createEtchedBorder());
        Panel5.setMaximumSize(new Dimension(2147483647, 160));
        Panel5.setMinimumSize(new Dimension(10, 120));
        Panel5.setPreferredSize(new Dimension(10, 120));

        border3 = BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(5,5,5,5));
        Panel6.setBorder(border3);
        Panel6.setLayout(borderLayout6);

        border1 = BorderFactory.createEmptyBorder(4,10,4,2);
        gridLayout1.setRows(4);
        gridLayout1.setColumns(1);
        gridLayout1.setHgap(2);
        gridLayout1.setVgap(4);
        Panel7.setBorder(border1);
        Panel7.setLayout(gridLayout1);
        Panel7.setMaximumSize(new Dimension(90, 10));
        Panel7.setMinimumSize(new Dimension(90, 10));
        Panel7.setPreferredSize(new Dimension(90, 10));

        border2 = BorderFactory.createEmptyBorder(4,5,4,5);
        gridLayout2.setRows(4);
        gridLayout2.setColumns(1);
        gridLayout2.setHgap(2);
        gridLayout2.setVgap(4);
        Panel8.setBorder(border2);
        Panel8.setLayout(gridLayout2);

        border4 = BorderFactory.createEmptyBorder(4,0,4,0);
        Panel9.setBorder(border4);
        Panel9.setMaximumSize(new Dimension(10, 50));
        Panel9.setMinimumSize(new Dimension(10, 50));
        Panel9.setPreferredSize(new Dimension(10, 50));

        Panel10.setBorder(border4);
        Panel10.setMaximumSize(new Dimension(10, 50));
        Panel10.setMinimumSize(new Dimension(10, 50));
        Panel10.setPreferredSize(new Dimension(10, 50));

        border7 = BorderFactory.createEmptyBorder(2,5,0,0);
        Panel11.setBorder(border7);
        Panel11.setMinimumSize(new Dimension(10, 25));
        Panel11.setPreferredSize(new Dimension(10, 25));
        Panel11.setLayout(borderLayout7);

        jHeader.setBorder(BorderFactory.createEtchedBorder());
        jHeader.setEditable(false);
        jText.setEditable(false);

        jLabel1.setText("From:");
        jLabel2.setText("Date:");
        jLabel3.setText("Receipients:");
        jLabel4.setText("Subject:");

        jButtonClear.setMnemonic('C');
        jButtonClear.setText("Clear");

        jLog.setBorder(BorderFactory.createEtchedBorder());
        jLog.setEditable(false);

        jToolBar.add(jButtonReceive, null);
        jToolBar.add(jButtonPrevious, null);
        jToolBar.add(jButtonNext, null);
        contentPane.add(jToolBar, BorderLayout.NORTH);

        jMenuBar1.add(jMenuFile);
        jMenuFile.add(jMenuFileProfile);
        jMenuFile.addSeparator();
        jMenuFile.add(jMenuFileExit);
        jMenuBar1.add(jMenuView);
        jMenuView.add(jMenuViewPrevious);
        jMenuView.add(jMenuViewNext);
        this.setJMenuBar(jMenuBar1);

        Panel7.add(jLabel1, null);
        Panel7.add(jLabel2, null);
        Panel7.add(jLabel3, null);
        Panel7.add(jLabel4, null);
        Panel8.add(jFrom, null);
        Panel8.add(jDate, null);
        Panel8.add(jReceipients, null);
        Panel8.add(jSubject, null);
        Panel5.add(Panel7, BorderLayout.WEST);
        Panel5.add(Panel8, BorderLayout.CENTER);

        jScrollPane1.setBorder(BorderFactory.createEtchedBorder());
        jScrollPane1.setBounds(new Rectangle(11, 44, 308, 73));
        jScrollPane1.getViewport().add(jText, null);
        Panel6.add(jScrollPane1, BorderLayout.CENTER);
        Panel2.add(Panel11, BorderLayout.SOUTH);
        Panel11.add(jStatus, BorderLayout.CENTER);
        Panel2.add(Panel5, BorderLayout.NORTH);
        Panel2.add(Panel6, BorderLayout.CENTER);

        border5 = BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(5,5,5,5));
        jScrollPane2.setBorder(border5);
        jScrollPane2.getViewport().add(jHeader, null);
        Panel3.add(jScrollPane2, BorderLayout.CENTER);
        Panel9.add(jButtonClear, null);
        Panel3.add(Panel9, BorderLayout.SOUTH);

        jScrollPane3.setBorder(border5);
        jScrollPane3.getViewport().add(jLog, null);
        Panel4.add(jScrollPane3, BorderLayout.CENTER);
        Panel10.add(jButtonClear1, null);
        Panel4.add(Panel10, BorderLayout.SOUTH);

        jTabbedPane1.add(Panel2, "Mail");
        jTabbedPane1.add(Panel3, "Header");
        jTabbedPane1.add(Panel4, "Transaction");

        Panel1.add(jTabbedPane1, BorderLayout.CENTER);

        contentPane.add(Panel1, BorderLayout.CENTER);
    }

    public void jMenuFileExit_actionPerformed(ActionEvent e) {
        String msg;
        boolean flag;
		
		try {
			if ((outData != null) && (inData != null) && (cs != null)) {
	            // QUIT
	            msg = "QUIT";
				flag = POP3Request(msg);
	            flag = POP3Response();
			}
			        
			if (outData != null) outData.close();
			if (inData != null) inData.close();
			if (cs != null) cs.close();
        }
		catch (IOException ex) {}
		
        System.exit(0);
    }

    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            jMenuFileExit_actionPerformed(null);
        }
    }

    void jMenuFileProfile_actionPerformed(ActionEvent e) {
        ProfileDialog2 dlg = new ProfileDialog2(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        dlg.setModal(true);
        dlg.show();
    }

    void jButtonReceive_actionPerformed(ActionEvent e) {
        try {
            loadProperties();

            if (receiveMail()) {
                currentMail = 1;
                
                boolean flag = showMail(currentMail) ;

                showObject(true);
            }
            else {
                showObject(false);
            }
        }
		catch (Exception ex) {
            ex.printStackTrace();
		}
    }

    void jButtonNext_actionPerformed(ActionEvent e) {
        currentMail ++;

        if (currentMail >= totalMail)
            currentMail = totalMail;

        if (!showMail(currentMail))
            currentMail --;

        showObject(true);
    }

    void jButtonPrevious_actionPerformed(ActionEvent e) {
        -- currentMail;

        if (currentMail <= 1)
            currentMail = 1;

        if (!showMail(currentMail))
            ++ currentMail;

        showObject(true);
    }
    void jButtonClear_actionPerformed(ActionEvent e) {
        jHeader.setText("");
    }

    void jButtonClear1_actionPerformed(ActionEvent e) {
        jLog.setText("");
    }

    void loadProperties() {
        // Line Separator
        linesep = System.getProperty("line.separator");

		try {
			Properties p = new Properties();

			FileInputStream in = new FileInputStream("pop3.properties");

			p.load(in);

            host = p.getProperty("pop3.host");
            port = p.getProperty("pop3.port");
            user = p.getProperty("pop3.username");
            pass = p.getProperty("pop3.password");

            in.close() ;
		}
		catch (Exception ex) {
            System.out.println(ex.getMessage() + linesep);
		}
	}

	// Send request to POP3 server
	boolean POP3Request(String msg) throws IOException {
        try {
            int length;

            length = msg.length();

            for (int i = 0; i < msg.length(); i++)
                outData.write(msg.charAt(i));

            outData.write('\r');
            outData.write('\n');
            outData.flush();

            jLog.append("C: " + msg + linesep);
            return true;
        }
        catch (IOException ex) {
            ex.printStackTrace();
            try {
                // Close I/O Stream and Socket
                outData.close();
                inData.close();
                cs.close();
            }
            catch (IOException ioex) {}
            return false;
        }
	}

	// Get response from POP3 server
	boolean POP3Response() throws IOException {
        String response;

        try {
            response = inData.readLine();
            jLog.append("S: " + response + linesep);

            if (!response.startsWith("+OK")) {
                JOptionPane.showMessageDialog((Component) null,
                    response,
                    "POP3 Error",
                    JOptionPane.ERROR_MESSAGE);

                outData.close();
                inData.close();
                cs.close();
                return false;
            }
            return true;
        }
        catch (IOException ex) {
            ex.printStackTrace();
            return false;
        }
	}

    boolean receiveMail() throws IOException {
        String msg;
		String response;

        try {
            // Connect to pop3 server
            jLog.append("C: Trying to connect to host " + host + ", port: " + port + linesep);

            cs = new Socket(InetAddress.getByName(host), Integer.parseInt(port));

            jLog.append("C: Connecting to " + host + ", port: " + port + linesep);

            try {
                // Create the I/O Stream of Socket
                inData  = new BufferedReader(new InputStreamReader(cs.getInputStream()));
                outData = new BufferedWriter(new OutputStreamWriter(cs.getOutputStream()));

                // should be "+OK hello from popgate"
                if (!POP3Response())
                    return false;

                // USER
                msg = "USER " + user;
                if (!POP3Request(msg))
                    return false;

                // should be "+OK password required."
                if (!POP3Response())
                    return false;

                // PASS
                msg = "PASS " + pass;
                if (!POP3Request(msg))
                    return false;

                // should be "+OK maildrop ready, .. messages"
                if (!POP3Response())
                    return false;

                // STAT
                msg = "STAT";
                if (!POP3Request(msg))
                    return false;

                // should be "+OK <# of Mail> <Mail Size>"
                response = inData.readLine();
                jLog.append("S: " + response + linesep);

                if (!response.startsWith("+OK")) {
                    JOptionPane.showMessageDialog((Component) null,
                        response,
                        "POP3 Error",
                        JOptionPane.ERROR_MESSAGE);
                    return false;
                }

                // Get the # and Size of Mail(s)
                // "+OK <#> <Size>"
                StringTokenizer tokenizer = new StringTokenizer(response, " ");

                int k = 0;

                while (tokenizer.hasMoreTokens()) {
                    k ++ ;
                    String temp = tokenizer.nextToken().trim();

                    if (k == 2) {
                        totalMail = Integer.parseInt(temp) ;
                    }
                    if (k == 3) {
                        mailSize = Integer.parseInt(temp) ;
                    }
                }

                return true;
            }
            catch (Exception ex) {
                ex.printStackTrace();
                try {
                    // Close I/O Stream and Socket
                    outData.close();
                    inData.close();
                    cs.close();
                }
                catch (IOException ioex) {}
                return false;
            }
        }
        catch (UnknownHostException e) {
            e.printStackTrace();
            return false;
        }
        catch (IOException ex) {
            ex.printStackTrace();
            return false;
        }
    }

    boolean showMail(int mailNo) {
        String msg;
		String response;
        String header = "", content = "";
        String from = "", to="";
        String date = "", subject="";
        boolean endofHeader = false;

        try {
            // Optional
            /*
            msg = "LIST " + mailNo;
            if (!POP3Request(msg))
                return false;

            // should be "+OK password required."
            if (!POP3Response())
                return false;
            */

            msg = "RETR " + mailNo;
            if (!POP3Request(msg))
                return false;

            response = inData.readLine();
            jLog.append("S: " + response + linesep);

            if (!response.startsWith("+OK")) {
                JOptionPane.showMessageDialog((Component) null,
                    response,
                    "POP3 Error",
                    JOptionPane.ERROR_MESSAGE);
                return false;
            }
            else {
	            while (true) {
	                response = inData.readLine();
	                jLog.append("S: " + response + linesep);
	
	                if (response.trim().equals("") && !endofHeader) {
	                    endofHeader = true;
	                    continue;
	                }
	
	                if (!endofHeader){
	                    // Process Header
	                    if (response.startsWith("Date:")) {
	                        date = response.substring(response.indexOf(":") + 2);
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("From:")) {
	                        from = response.substring(response.indexOf(":") + 2);
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("Reply-To:")) {
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("Subject:")) {
	                        subject = response.substring(response.indexOf(":") + 2);
	
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("To:")) {
	                        if (to.equals(""))
	                            to = response.substring(response.indexOf(":") + 2);
	                        else
	                            to = to + ", " + response.substring(response.indexOf(":") + 2);
	
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("Receipients:")) {
	                        if (to.equals(""))
	                            to = response.substring(response.indexOf(":") + 2);
	                        else
	                            to = to + ", " + response.substring(response.indexOf(":") + 2);
	
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("MIME-Version:")) {
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("Content-Transfer-Encoding:")) {
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("Content-Type:")) {
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("Content-Description:")) {
	                        header = header + response + linesep;
	                    }
	                    if (response.startsWith("Message-ID:")) {
	                        header = header + response + linesep;
	                    }
	                }
	                else {
	                    // Process Content
	                    if (response.startsWith(".")){
	                        // For test only. Not necessary in the real world.
	                        content = content + response + linesep;
	                        break;
	                    }
	
	                    content = content + response + linesep;
	                }
	            }
	
	            jFrom.setText(from);
	            jFrom.setCaretPosition(0);
	            jDate.setText(date);
	            jDate.setCaretPosition(0);
	            jReceipients.setText(to);
	            jReceipients.setCaretPosition(0);
	            jSubject.setText(subject);
	            jSubject.setCaretPosition(0);
	            jHeader.setText(header);
	            jHeader.setCaretPosition(0);
	            jText.setText(content);
	            jText.setCaretPosition(0);
	
	            jStatus.setText("Total: " + totalMail + " (Size: " + mailSize + ") Current: " + mailNo);
	
	            return true;
			}	           
        }
        catch (IOException ex) {
            ex.printStackTrace();
            return false;
        }
    }

    void showObject(boolean flag) {
        if (flag) {
            jButtonClear.setEnabled(true);
            jMenuView.setEnabled(true);

            if ((totalMail > 1) && (currentMail == 1)) {
                jButtonPrevious.setEnabled(false);
                jMenuViewPrevious.setEnabled(false);
                jButtonNext.setEnabled(true);
                jMenuViewNext.setEnabled(true);
            }
            else if ((currentMail < totalMail) && (currentMail > 1)) {
                jButtonPrevious.setEnabled(true);
                jMenuViewPrevious.setEnabled(true);
                jButtonNext.setEnabled(true);
                jMenuViewNext.setEnabled(true);
            }
            else if ((currentMail == totalMail) && (currentMail > 1)) {
                jButtonPrevious.setEnabled(true);
                jMenuViewPrevious.setEnabled(true);
                jButtonNext.setEnabled(false);
                jMenuViewNext.setEnabled(false);
            }
        }
        else {
            jButtonPrevious.setEnabled(false);
            jButtonNext.setEnabled(false);
            jButtonClear.setEnabled(false);
            jMenuView.setEnabled(false);
            jMenuViewPrevious.setEnabled(false);
            jMenuViewNext.setEnabled(false);
        }
    }
}

